﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using System.Timers;
//using System.Windows.Threading;

namespace Test
{
    public class TestClassForJson
    {
        public String StringProp { get; set; }
        public int IntProp { get; set; }
        public bool BoolProp { get; set; }
    }

    public class Class1
    {
        public Class1()
        {
            AppDomain.CurrentDomain.AssemblyResolve += CurrentDomain_AssemblyResolve;
        }

        private System.Reflection.Assembly CurrentDomain_AssemblyResolve(object sender, ResolveEventArgs args)
        {
            if (args.Name.Contains("System.Web.Helpers"))
            {
                using (var stream = Assembly.GetExecutingAssembly().GetManifestResourceStream("Test.System.Web.Helpers.dll"))
                {
                    Byte[] assemblyData = new Byte[stream.Length];
                    stream.Read(assemblyData, 0, assemblyData.Length);
                    return Assembly.Load(assemblyData);
                }
            }

            return null;
        }
    
        public delegate void ExternalEventHandler(String Source, String Message, String Data);

        public event ExternalEventHandler TestEvent;

        public String TestProp { get; set; }
        public String TestField;

        public String TestMethod(String Param)
        {
            return Param + " + Добавлено из компоненты";
        }

        public String TestJson()
        {
            int[] a = new int[3];
            a[0] = 111;
            a[1] = 222;
            a[2] = 333;
            
            return System.Web.Helpers.Json.Encode(a);
        }

        public String FromJsonArrayToString(String jsonarray)
        {
            byte[] b = System.Web.Helpers.Json.Decode<byte[]>(jsonarray);
            char[] ch = new char[b.Length];
            for (int i = 0; i < b.Length; i++)
            {
                ch[i] = Convert.ToChar(b[i]);
            }

            string ret = new String(ch);
            return ret;
        }

        public void ВключитьТаймер()
        {
            if (timer == null)
            {
                timer = new Timer(1000);
                timer.Elapsed+=timer_Elapsed;
                timer.Start();
            }
        }

        public void ВыключитьТаймер()
        {
            if (timer != null)
            {
                timer.Elapsed -= timer_Elapsed;
                timer.Stop();
                timer = null;
            }
        }

        private void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            if (TestEvent != null)
            {
                TestEvent("Timer", "ИзменилосьВремя", DateTime.Now.ToString());
            }
        }

        private Timer timer;
     
    }
}
